diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
index f29dc48b6..81a98d504 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
@@ -21,7 +21,8 @@ import static net.minecraft.client.render.block.model.BlockModel.FULL_CUBE_THRES
 
 public final class RenderBlocks {
     public final @NotNull Minecraft mc;
-    public IconCoordinate overrideBlockTexture;
+    public @Nullable IconCoordinate overrideBlockTexture;
+    public @Nullable Integer overrideLightmap;
     public boolean flipTexture;
     public boolean renderAllFaces;
     public byte renderBitMask;
@@ -57,6 +58,7 @@ public final class RenderBlocks {
 
     public RenderBlocks() {
         this.overrideBlockTexture = null;
+        this.overrideLightmap = null;
         this.flipTexture = false;
         this.renderAllFaces = false;
         this.useInventoryTint = true;
@@ -77,6 +79,7 @@ public final class RenderBlocks {
         this.useInventoryTint = true;
         this.flipTexture = false;
         this.overrideBlockTexture = null;
+        this.overrideLightmap = null;
         this.uvRotateEast = 0;
         this.uvRotateWest = 0;
         this.uvRotateSouth = 0;
@@ -248,54 +251,62 @@ public final class RenderBlocks {
                               int dirX, int dirY, int dirZ, float depth,
                               int topX, int topY, int topZ, float topP, float botP,
                               int lefX, int lefY, int lefZ, float lefP, float rigP) {
+        this.colorRedTopLeft = this.colorRedBottomLeft = this.colorRedBottomRight = this.colorRedTopRight = r;
+        this.colorGreenTopLeft = this.colorGreenBottomLeft = this.colorGreenBottomRight = this.colorGreenTopRight = g;
+        this.colorBlueTopLeft = this.colorBlueBottomLeft = this.colorBlueBottomRight = this.colorBlueTopRight = b;
+
         boolean ao = GameSettings.AMBIENT_OCCLUSION.value && block.emission == 0;
         boolean isFullCube = depth <= FULL_CUBE_THRESHOLD;
 
-        if (ao) {
-            int dirX2 = dirX;
-            int dirY2 = dirY;
-            int dirZ2 = dirZ;
-
-            if (!isFullCube) {
-                dirX2 = 0;
-                dirY2 = 0;
-                dirZ2 = 0;
-            }
-
-            boolean topT = this.cache.getOpacity(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
-            boolean botT = this.cache.getOpacity(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
-            boolean lefT = this.cache.getOpacity(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
-            boolean rigT = this.cache.getOpacity(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
-
-            boolean topLefT = this.cache.getOpacity(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ);
-            boolean topRigT = this.cache.getOpacity(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ);
-            boolean botLefT = this.cache.getOpacity(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ);
-            boolean botRigT = this.cache.getOpacity(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ);
-
-            byte lmcCen = this.cache.getLightIndex(dirX2, dirY2, dirZ2);
-
-            byte lmcTop = topT ? lmcCen : this.cache.getLightIndex(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
-            byte lmcBot = botT ? lmcCen : this.cache.getLightIndex(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
-            byte lmcLef = lefT ? lmcCen : this.cache.getLightIndex(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
-            byte lmcRig = rigT ? lmcCen : this.cache.getLightIndex(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
-
-            byte lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : this.cache.getLightIndex(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ));
-            byte lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : this.cache.getLightIndex(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ));
-            byte lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : this.cache.getLightIndex(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ));
-            byte lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : this.cache.getLightIndex(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ));
-
-            this.lightIndexTopLeft = LightIndexHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
-            this.lightIndexTopRight = LightIndexHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
-            this.lightIndexBottomLeft = LightIndexHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
-            this.lightIndexBottomRight = LightIndexHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
-        } else {
-            int lmc;
-            if (!isFullCube) {
-                lmc = block.getLightIndex(worldSource, tilePos);
+        if (this.overrideLightmap == null) {
+            if (ao) {
+                int dirX2 = dirX;
+                int dirY2 = dirY;
+                int dirZ2 = dirZ;
+
+                if (!isFullCube) {
+                    dirX2 = 0;
+                    dirY2 = 0;
+                    dirZ2 = 0;
+                }
+
+                boolean topT = this.cache.getOpacity(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
+                boolean botT = this.cache.getOpacity(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
+                boolean lefT = this.cache.getOpacity(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
+                boolean rigT = this.cache.getOpacity(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
+
+                boolean topLefT = this.cache.getOpacity(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ);
+                boolean topRigT = this.cache.getOpacity(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ);
+                boolean botLefT = this.cache.getOpacity(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ);
+                boolean botRigT = this.cache.getOpacity(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ);
+
+                byte lmcCen = this.cache.getLightIndex(dirX2, dirY2, dirZ2);
+
+                byte lmcTop = topT ? lmcCen : this.cache.getLightIndex(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
+                byte lmcBot = botT ? lmcCen : this.cache.getLightIndex(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
+                byte lmcLef = lefT ? lmcCen : this.cache.getLightIndex(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
+                byte lmcRig = rigT ? lmcCen : this.cache.getLightIndex(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
+
+                byte lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : this.cache.getLightIndex(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ));
+                byte lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : this.cache.getLightIndex(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ));
+                byte lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : this.cache.getLightIndex(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ));
+                byte lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : this.cache.getLightIndex(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ));
+
+                this.lightIndexTopLeft = LightIndexHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
+                this.lightIndexTopRight = LightIndexHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
+                this.lightIndexBottomLeft = LightIndexHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
+                this.lightIndexBottomRight = LightIndexHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
             } else {
-                lmc = block.getLightIndex(worldSource, tilePos.add(dirX, dirY, dirZ, new TilePos()));
+                int lmc;
+                if (!isFullCube) {
+                    lmc = block.getLightIndex(worldSource, tilePos);
+                } else {
+                    lmc = block.getLightIndex(worldSource, tilePos.add(dirX, dirY, dirZ, new TilePos()));
+                }
+                this.lightIndexTopLeft = this.lightIndexBottomLeft = this.lightIndexBottomRight = this.lightIndexTopRight = lmc;
             }
-            this.lightIndexTopLeft = this.lightIndexBottomLeft = this.lightIndexBottomRight = this.lightIndexTopRight = lmc;
+        } else {
+            this.lightIndexTopLeft = this.lightIndexBottomLeft = this.lightIndexBottomRight = this.lightIndexTopRight = this.overrideLightmap;
         }
 
         float lightTR;
@@ -357,9 +368,6 @@ public final class RenderBlocks {
             lightTL = lightBL = lightBR = lightTR = brightness;
         }
 
-        this.colorRedTopLeft = this.colorRedBottomLeft = this.colorRedBottomRight = this.colorRedTopRight = r;
-        this.colorGreenTopLeft = this.colorGreenBottomLeft = this.colorGreenBottomRight = this.colorGreenTopRight = g;
-        this.colorBlueTopLeft = this.colorBlueBottomLeft = this.colorBlueBottomRight = this.colorBlueTopRight = b;
         float tl = topP * lightTL + (1 - topP) * lightBL;
         float tr = topP * lightTR + (1 - topP) * lightBR;
         float bl = botP * lightTL + (1 - botP) * lightBL;
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
index 1d87a4884..73a8af518 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
@@ -15,20 +15,20 @@ public class DynamicTextureCustom extends DynamicTexture {
 	private static final Logger LOGGER = LogUtils.getLogger();
 	private static final Random rand = new Random();
 	
-	private final int frameCount;
-	private final byte[][] frameData;
+	protected final int frameCount;
+	protected final byte[][] frameData;
 
-	private final AnimationProperties properties;
+    protected final AnimationProperties properties;
 
-	private int currentIndex = 0;
-	private final int indices;
+    protected int currentIndex = 0;
+    protected final int indices;
 
-	private int currentFrame = -1;
-	private int previousFrame = -1;
-	private int delayUntilNextFrame = 0;
-	private int frameLength = 0;
+    protected int currentFrame = -1;
+    protected int previousFrame = -1;
+    protected int delayUntilNextFrame = 0;
+    protected int frameLength = 0;
 
-	private final boolean tickWhenPaused;
+    protected final boolean tickWhenPaused;
 	
 	public DynamicTextureCustom(IconCoordinate texture, AnimationProperties animationProperties) {
 		super(texture);
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucket.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucket.java
new file mode 100644
index 000000000..a0a6d2f40
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucket.java
@@ -0,0 +1,69 @@
+package net.minecraft.client.render.item.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemBucket;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Set;
+
+public abstract class ItemModelBucket extends ItemModelStandard {
+
+    protected final Map<NamespaceID, IconCoordinate[]> bucketIcons = new HashMap<>();
+
+    public ItemModelBucket(Item item, String namespace) {
+        super(item, namespace);
+    }
+
+    protected void initializeIcons(String namespace, String prefix, int maxCharges, Set<NamespaceID> validStates) {
+        IconCoordinate[] emptyArray = new IconCoordinate[1];
+        emptyArray[0] = TextureRegistry.getTexture(namespace + ":item/" + prefix + "/empty");
+        this.bucketIcons.put(ItemBucket.STATE_EMPTY, emptyArray);
+
+        for (NamespaceID stateId : validStates) {
+            if (ItemBucket.STATE_EMPTY.equals(stateId)) continue;
+
+            String stateName = stateId.value();
+            IconCoordinate[] chargesArray = new IconCoordinate[maxCharges + 1];
+
+            for (int c = 1; c <= maxCharges; c++) {
+                String path = namespace + ":item/" + prefix + "/" + stateName + "_" + c;
+                chargesArray[c] = TextureRegistry.getTexture(path);
+            }
+            this.bucketIcons.put(stateId, chargesArray);
+        }
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack) {
+        NamespaceID state = ItemBucket.getState(itemStack);
+        int charges = ItemBucket.getCharges(itemStack);
+
+        int maxForThisBucket = 1;
+        if (itemStack.getItem() instanceof ItemBucket bucket) {
+            maxForThisBucket = bucket.maxCharges;
+        }
+
+        if (!ItemBucket.STATE_EMPTY.equals(state) && charges <= 0) {
+            long cycleTime = 620;
+            charges = (int) ((System.currentTimeMillis() / cycleTime) % maxForThisBucket) + 1;
+        }
+
+        charges = Math.max(0, Math.min(charges, maxForThisBucket));
+        IconCoordinate[] iconsForState = bucketIcons.get(state);
+
+        if (iconsForState == null || charges >= iconsForState.length) {
+            return super.getIcon(entity, itemStack);
+        }
+
+        IconCoordinate icon = iconsForState[charges];
+        return (icon != null) ? icon : super.getIcon(entity, itemStack);
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucketIron.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucketIron.java
new file mode 100644
index 000000000..0e6313688
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucketIron.java
@@ -0,0 +1,20 @@
+package net.minecraft.client.render.item.model;
+
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemBucket;
+import net.minecraft.core.util.collection.NamespaceID;
+
+import java.util.Set;
+
+public class ItemModelBucketIron extends ItemModelBucket {
+    public ItemModelBucketIron(Item item, String namespace) {
+        super(item, namespace);
+        Set<NamespaceID> validStates = Set.of(
+            ItemBucket.STATE_WATER,
+            ItemBucket.STATE_LAVA,
+            ItemBucket.STATE_MILK,
+            ItemBucket.STATE_ICECREAM
+        );
+        this.initializeIcons(namespace, "bucket_iron", 1, validStates);
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucketSteel.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucketSteel.java
new file mode 100644
index 000000000..dff72dccb
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBucketSteel.java
@@ -0,0 +1,21 @@
+package net.minecraft.client.render.item.model;
+
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemBucket;
+import net.minecraft.core.util.collection.NamespaceID;
+
+import java.util.Set;
+
+public class ItemModelBucketSteel extends ItemModelBucket {
+    public ItemModelBucketSteel(Item item, String namespace) {
+        super(item, namespace);
+        Set<NamespaceID> validStates = Set.of(
+            ItemBucket.STATE_WATER,
+            ItemBucket.STATE_LAVA,
+            ItemBucket.STATE_MILK,
+            ItemBucket.STATE_ICECREAM
+        );
+
+        this.initializeIcons(namespace, "bucket_steel", 3, validStates);
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 8c5006024..0621b6019 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -241,9 +241,10 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Items.DOOR_OAK, "minecraft"));
         addDispatch(new ItemModelStandard(Items.DOOR_GLASS, "minecraft"));
         addDispatch(new ItemModelDoorPainted(Items.DOOR_OAK_PAINTED));
-        addDispatch(new ItemModelStandard(Items.BUCKET, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.BUCKET_WATER, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.BUCKET_LAVA, "minecraft").setFullBright());
+        addDispatch(new ItemModelBucketIron(Items.BUCKET_IRON, "minecraft"));
+        addDispatch(new ItemModelBucketSteel(Items.BUCKET_STEEL, "minecraft"));
+      //addDispatch(new ItemModelStandard(Items.BUCKET_WATER, "minecraft"));
+      //addDispatch(new ItemModelStandard(Items.BUCKET_LAVA, "minecraft").setFullBright());
         addDispatch(new ItemModelStandard(Items.MINECART, "minecraft"));
         addDispatch(new ItemModelStandard(Items.SADDLE, "minecraft"));
         addDispatch(new ItemModelStandard(Items.DOOR_IRON, "minecraft"));
@@ -251,7 +252,7 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Items.AMMO_SNOWBALL, "minecraft"));
         addDispatch(new ItemModelStandard(Items.BOAT, "minecraft"));
         addDispatch(new ItemModelStandard(Items.LEATHER, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.BUCKET_MILK, "minecraft"));
+      //addDispatch(new ItemModelStandard(Items.BUCKET_MILK, "minecraft"));
         addDispatch(new ItemModelStandard(Items.BRICK_CLAY, "minecraft"));
         addDispatch(new ItemModelStandard(Items.CLAY, "minecraft"));
         addDispatch(new ItemModelStandard(Items.SUGARCANE, "minecraft"));
@@ -345,7 +346,7 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Items.OLIVINE, "minecraft"));
         addDispatch(new ItemModelStandard(Items.AMMO_PEBBLE, "minecraft"));
         addDispatch(new ItemModelStandard(Items.FOOD_CHERRY, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.BUCKET_ICECREAM, "minecraft"));
+      //addDispatch(new ItemModelStandard(Items.BUCKET_ICECREAM, "minecraft"));
         addDispatch(new ItemModelStandard(Items.AMMO_ARROW_PURPLE, "minecraft"));
         addDispatch(new ItemModelLabel(Items.LABEL, "minecraft"));
         addDispatch(new ItemModelStandard(Items.JAR, "minecraft"));
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/generator/TextureGeneratorRubyglassConduit.java b/game/client/src/main/java/net/minecraft/client/render/texture/generator/TextureGeneratorRubyglassConduit.java
new file mode 100644
index 000000000..fa494b0f2
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/generator/TextureGeneratorRubyglassConduit.java
@@ -0,0 +1,81 @@
+package net.minecraft.client.render.texture.generator;
+
+import net.minecraft.client.Minecraft;
+import javax.imageio.ImageIO;
+import java.awt.image.BufferedImage;
+import java.io.InputStream;
+
+public class TextureGeneratorRubyglassConduit {
+
+    private static int[] palette = null;
+
+    public static BufferedImage generateConduitTexture(String shape, int strength, String layer) {
+        loadPalette();
+        int color = palette[Math.max(0, Math.min(10, strength))];
+
+        String basePath = "/assets/minecraft/textures/block/rubyglass/conduit/" + shape + "_base.png";
+        String maskPath = "/assets/minecraft/textures/block/rubyglass/conduit/" + shape + "_mask.png";
+
+        try {
+            BufferedImage baseImg = loadImage(basePath);
+            BufferedImage maskImg = loadImage(maskPath);
+
+            if (baseImg == null || maskImg == null) return null;
+
+            int width = baseImg.getWidth();
+            int height = baseImg.getHeight();
+            BufferedImage result = new BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB);
+
+            for (int x = 0; x < width; x++) {
+                for (int y = 0; y < height; y++) {
+                    int basePixel = baseImg.getRGB(x, y);
+                    int maskPixel = maskImg.getRGB(x, y);
+
+                    boolean isRedstone = ((maskPixel >> 24) & 0xFF) > 128 && ((maskPixel >> 16) & 0xFF) > 128;
+
+                    if (layer.equals("emissive")) {
+                        if (isRedstone) {
+                            result.setRGB(x, y, (0xFF << 24) | color);
+                        } else {
+                            result.setRGB(x, y, 0x00000000);
+                        }
+                    } else {
+                        if (isRedstone) {
+                            result.setRGB(x, y, (0xFF << 24) | color);
+                        } else {
+                            result.setRGB(x, y, basePixel);
+                        }
+                    }
+                }
+            }
+            return result;
+        } catch (Exception e) {
+            e.printStackTrace();
+            return null;
+        }
+    }
+
+    private static BufferedImage loadImage(String path) {
+        try (InputStream stream = Minecraft.getMinecraft().texturePackList.getResourceAsStream(path)) {
+            if (stream != null) return ImageIO.read(stream);
+        } catch (Exception ignored) {}
+        return null;
+    }
+
+    private static void loadPalette() {
+        if (palette != null) return;
+        palette = new int[11];
+
+        try {
+            BufferedImage img = loadImage("/assets/minecraft/textures/block/rubyglass/palette.png");
+            if (img != null) {
+                for (int i = 0; i < 11; i++) {
+                    int x = Math.min(i, img.getWidth() - 1);
+                    palette[i] = img.getRGB(x, 0) & 0xFFFFFF;
+                }
+            }
+        } catch (Exception e) {
+            e.printStackTrace();
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
index d1c4725ca..107722067 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
@@ -229,7 +229,7 @@ public class AtlasStitcher {
         }
         BufferedImage image = CustomAtlasHandler.getTextureOverride(Minecraft.getMinecraft().texturePackList, path + ".png");
         if(image == null) {
-            TexturePack pack = Minecraft.getMinecraft().texturePackList.getHighestPriorityTexturePackWithFile(path + ".png");
+            TexturePack pack = Minecraft.getMinecraft().texturePackList.getHighestPriorityTexturePackWithFile(source + ".png");
             if (pack != null) {
                 for (int attempt = 0; attempt < 3; attempt++) {
                     try (InputStream stream = pack.getResourceAsStream(path)) {
